#!/usr/bin/php -d memory_limit=512M
<?php
/**
 * WordPress add admin user
 *
 * PHP version 5
 *
 * @category   WordPress_Tools
 * @package    WordPress
 * @subpackage Users
 * @author     Marcin Pietrzak <marcin@iworks.pl>
 * @license    http://iworks.pl/ BSD
 * @version    SVN: $Id: add_admin.php 12433 2013-07-15 06:24:14Z illi $
 * @link       http://iworks.pl/
 *
 */

if ( isset( $_SERVER[ 'SERVER_NAME' ] ) ) {
    die( 'not allow with www' );
}
$_SERVER['HTTP_HOST'] = null;

/**
 * load WordPress without theme and plugins
 */
define( 'WP_USE_THEMES', false );
define( 'WP_PLUGIN_DIR', false );

require 'wp-load.php';

if ( 3 > count( $argv ) ) {
    echo 'Użycie:'.PHP_EOL;
    echo PHP_EOL;
    echo'./add_admin.php login email [password]';
    echo PHP_EOL;
    echo PHP_EOL;
}

$user_name  = $argv[1];
$user_email = $argv[2];
$password = wp_generate_password( $length = 16, false );
if ( isset( $argv[3] ) ) {
    $password = $argv[3];
}

$user_id = function_exists( 'username_exists' )? username_exists( $user_name ):null;

$wp_user_object = new WP_User( $user_id );
foreach ( array( 'administrator', 'editor', 'author', 'contributor', 'subscriber' ) as $role ) {
    $wp_user_object->remove_role( $role );
}
$wp_user_object->add_role( 'administrator' );

if ( function_exists( 'username_exists' ) && username_exists( $user_name ) ) {
    die( sprintf ( 'User: %s alredy exists!%s', $user_name, PHP_EOL ) );
}
if ( function_exists( 'email_exists' ) && email_exists( $user_email ) ) {
    die( sprintf ( 'User email: %s alredy exists!%s', $user_email, PHP_EOL ) );
}

$user_id = wp_create_user( $user_name, $password, $user_email );

printf( '%s (%s): %s%s', $user_name, $user_email, $password, PHP_EOL );

$wp_user_object = new WP_User( $user_id );
$wp_user_object->remove_role( 'subscriber' );
$wp_user_object->add_role( 'administrator' );
